/// Won't run !
class Arbitrage {

  /// Problem size.
  protected final static int N = 12;

  /// Exchange rate matrix.
  protected static double m[][] = new double[N][N];

  /// Working copy of arbitrage sequence.
  protected static int result[] = new int[N];

  /// Used currencies.
  protected static boolean used[] = new boolean[N];

  /// Actual maximal sequence length (search depth).
  protected static int len;

  /// Best arbitrage profit found so far.
  protected static double best;

  /// Best arbitrage sequence found so far.
  protected static int bestSeq[] = new int[N];

  /// Length of the best sequence found so far.
  protected static int bestLen;

  public Arbitrage () {
    bestLen = len = 0;
    best = 0.0;
  }

  /// Recursive solver routine (dynamic programming).
  protected void solve ( double mul, int i )
  {
    int j;
    double act;
    if ( i + 1 == len )
      for ( j = 0; j < N; j++ ) {
        if ( !used[j] &&
             (act = mul * m[result[i-1]][j] * m[j][result[0]]) > best ) {
          best = act;
          bestLen = len;
          System.arraycopy(result,0,bestSeq,0,i);
          bestSeq[i] = j;
        }
      }
    else
      for ( j = 0; j < N; j++ )
        if ( !used[j] ) {
          used[j] = true;
          result[i] = j;
          solve(mul*m[result[i-1]][j],i+1);
          used[j] = false;
        }
  }

}

/*
  Arbitrage sequence lookup (double[12][12] matrix):
BartonXP/2G (AsusA7V600,512M/333,IC35L040A,WXPH,I5.0.1)        35.08s  100%
BartonXP/2G (AsusA7V600,512M/333,IC35L040A,WXPH,J1.3.1IBM)     41.56s  118%
BartonXP/2G (AsusA7V600,512M/333,IC35L040A,WXPH)               42.83s  122%
BartonXP/2G (AsusA7V600,512M/333,IC35L040A,WXPH,J1.4.1jrockit) 48.30s  138%
BartonXP/2G (AsusA7V600,512M/333,IC35L040A,WXPH,J5.00.3802)    56.31s  161%
BartonXP/2G (AsusA7V600,512M/333,IC35L040A,WXPH,J1.4.2bHS)     61.09s  174%
*/
