/**
 * Drawing capability (object is able to draw itself).
 */
interface Drawable {

  /**
   * Draw (render) myself at its exact coordinates.
   * Field origin (upper left corner) is given in [originX,originY].
   * @param  canvas Canvas which drawing must be directed to.
   * @param  originX X-coordinate of the field origin.
   * @param  originY Y-coordinate of the field origin.
   */
  void draw ( Object canvas, int originX, int originY );

  /**
   * Draw (render) myself at the given coordinates [x,y]
   * (for GUI, legend, etc.).
   * @param  canvas Canvas which drawing must be directed to.
   * @param  x Absolute x-coordinate of the object.
   * @param  y Absolute y-coordinate of the object.
   */
  void drawAt ( Object canvas, int x, int y );

}
