class A {

	protected int x;

	public A ()
	{
  	x = -1; // default
	}

	/** Private = final method! */
	private void m ()
	{
		x = 1;
	}

	/** Uses private method to set 'x' member */
	public void usage ()
	{
		m();
	}

}

class B extends A {

  /** "Overriding" method 'm' - in fact this is DIFFERENT method */
	public void m ()
	{
		x = 10;
	}

	/** Overriding method 'usage' - it hasn't any chance to know about 'super.m()' */
	public void usage ()
	{
  	m();
	}

	public void superUsage ()
	{
  	super.usage();
	}

	public static void main ( String[] args )
	  {
	    B instanceB = new B();
	    instanceB.usage();
	    System.out.println("After calling 'm()': B.x = " + instanceB.x);
	    instanceB.superUsage();
	    System.out.println("After calling 'super.m()': B.x = " + instanceB.x);
	  }
}
