class Valuated {

	protected int price;

	/** Sets the 'price' member. */
	public void calculatePrice ()
	{
  	price = -1;     // default value = invalid price
	}

	public Valuated ()
	{
  	// Beware of calling overridable methods in constructors!
  	calculatePrice();
	}

	/** Public output. */
	public void print ()
	{
		System.out.println(""+getClass().toString()+".price = "+price);
	}

}

class Car extends Valuated {

  /** Purchase cost. */
  protected int purchaseCost;

  /** Age in years */
  protected double age;

  /** Aging coefficient (the higher -> the faster a car does lose its value). */
  protected final double AGING = 0.45;

	/** Sets the 'price' member according to 'purchaseCost' and 'age'. */
	public void calculatePrice ()
	{
  	price = (int)(purchaseCost * Math.exp(-AGING * age));
	}

	public Car ( int _purchaseCost, double _age )
	{
  	// !!! Implicit call of 'super()' and 'calculatePrice()' BEFORE members were initialized !!!
  	purchaseCost = _purchaseCost;
  	age          = _age;
	}

	public static void main ( String[] args )
  {
    Valuated general = new Valuated();
    general.print();
    Car volvo = new Car(685000,2.5);
	  volvo.print();
	  volvo.calculatePrice();
	  volvo.print();
  }

}
